include \masm32\include\masm32rt.inc

Store2Mem MACRO TheArgs:VARARG
LOCAL argct, arg
  argct = 0
  FOR arg, <TheArgs>
	argct = argct + 1
  ENDM
  MyBuf CATSTR <Store2MemBuffer>, %argct	; we check if the buffer has been created
  % ifndef MyBuf
	.data?
	  MyBuf	dd argct+1 dup(?)
	.code
	  mov MyBuf[argct*4], offset MyBuf+argct*4	; 10 bytes overhead per argct
  endif
  xchg esp, MyBuf[argct*4]
  FOR arg, <TheArgs>
	push arg
  ENDM
  add esp, argct*4
  xchg esp, [esp]
ENDM

Store5J Macro arg1, arg2, arg3, arg4, arg5
  xchg esp, Store5Buffer[20]
  push arg1
  push arg2
  push arg3
  push arg4
  push arg5
  add esp, 5*4
  xchg esp, [esp]
ENDM

Store5D Macro arg1, arg2, arg3, arg4, arg5
  push arg5
  pop Store5Buffer[16]
  push arg4
  pop Store5Buffer[12]
  push arg3
  pop Store5Buffer[8]
  push arg2
  pop Store5Buffer[4]
  push arg1
  pop Store5Buffer
ENDM

Store5Q Macro arg1, arg2, arg3, arg4, arg5
  IFNDEF s5_cntr
	s5_cntr = 0
  .data
	_esp dd OFFSET Store5Buffer + (sizeof Store5Buffer)  
  .code
  ENDIF
  IF s5_cntr+5 GT ((SIZEOF Store5Buffer)/4)
	%echo ERR: overflow ;)
	EXITM
  ENDIF
  cntr = 1
  xchg _esp,esp
  REPEAT 5
	push getarg(%(cntr),<arg1,arg2,arg3,arg4,arg5>)
	cntr = cntr + 1
  ENDM
  xchg esp,_esp
  s5_cntr = s5_cntr + 5
ENDM

safeprint macro arg
pushad
print arg, 13, 10
popad
endm

.data?
MyDword1	dd ?
MyDword2	dd ?
Store5Buffer	dd 6 dup(?)

.code
start:
	mov Store5Buffer[5*4], offset Store5Buffer+5*4		; 10 bytes overhead for Store5J
	mov ebx, esp	; just a little test whether the stack is still OK after the macros
	mov eax, 12345678h
	mov ecx, 11111111h
	mov edx, 22222222h
	mjs5:
	REPEAT 5		; per argct 10 bytes overhead; then x per macro call: 10+5*(27+17)=230
	Store2Mem MyDword1, ecx, edx, esi, MyDword2	; 12 plus one per reg32, 6 per global var: 12+2*6+3=27
	Store2Mem eax, ecx, edx, esi, edi				; 12 plus one per reg32, 6 per global var: 12+5=17
	ENDM
	mje5:
	push ebx
	mov ebx, offset Store2MemBuffer5	; defined below
	.if edi==[ebx+0]
		safeprint "arg 1 ok"
	.endif
	.if esi==[ebx+4]
		safeprint "arg 2 ok"
	.endif
	.if edx==[ebx+8]
		safeprint "arg 3 ok"
	.endif
	.if ecx==[ebx+12]
		safeprint "arg 4 ok"
	.endif
	.if eax==[ebx+16]
		safeprint "arg 5 ok"
	.endif
	pop ebx
;	checking global accessibility of the buffer names:
	mov edx, offset Store2MemBuffer5	; defined above
	mov edx, offset Store2MemBuffer2	; defined below
;	mov edx, offset Store2MemBuffer3	; undefined
	mjs2:
	REPEAT 5		; per argct 10 bytes overhead; then x per macro call: 10+5*(19+14)=175
	Store2Mem MyDword1, ecx 	; 12 plus one per reg32, 6 per global var: 12+6+1=19
	Store2Mem eax, ecx	; 12 plus one per reg32, 6 per global var: 12+2=14
	ENDM
	mje2:

	mjs:
	REPEAT 5
	Store5J MyDword1, ecx, edx, esi, MyDword2	; 12 plus one per reg32, 6 per global var: 12+2*6+3=27
	Store5J eax, ecx, edx, esi, edi				; 12 plus one per reg32, 6 per global var: 12+5=17
	ENDM
	mje:

	mds:
	REPEAT 5
	Store5D MyDword1, ecx, edx, esi, MyDword2
	Store5D eax, ecx, edx, esi, edi
	ENDM
	mde:

	mqs:
	REPEAT 5
	Store5Q MyDword1, ecx, edx, esi, MyDword2
	Store5Q eax, ecx, edx, esi, edi
	ENDM
	mqe:

	sub ebx, esp	; just a little test whether the stack is still OK after the macros
	je @F
	print "Somebody just crashed the stack, shame on you!", 13, 10
@@:
	mov eax, mje5
	sub eax, mjs5
	print str$(eax), " bytes for 10*Store2Mem, 5 args", 13, 10
	mov eax, mje2
	sub eax, mjs2
	print str$(eax), " bytes for 10*Store2Mem, 2 args", 13, 10
	mov eax, mje
	sub eax, mjs
	add eax, 10		; the overhead
	print str$(eax), " bytes for 10*macJ", 13, 10
;	mov eax, mde
;	sub eax, mds
;	print str$(eax), " bytes for 10*macD", 13, 10
;	mov eax, mqe
;	sub eax, mqs
;	print str$(eax), " bytes for 10*macQ, qWord cheats!!!", 13, 10, 10
	inkey chr$(13, 10, 10, "No crash so far, thanks")
	exit

end start
OPT_Wait	0
OPT_Tmp2Asm	1
